findutils/*: move usage and applet bits to *.c files
[oweals/busybox.git] / scripts / trylink
1 #!/bin/sh
2
3 debug=false
4
5 # Linker flags used:
6 #
7 # Informational:
8 # --warn-common
9 # -Map $EXE.map
10 # --verbose
11 #
12 # Optimizations:
13 # --sort-common                 reduces padding
14 # --sort-section alignment      reduces padding
15 # --gc-sections                 throws out unused sections,
16 #                               does not work for shared libs
17 # -On                           Not used, maybe useful?
18 #
19 # List of files to link:
20 # $l_list                       == --start-group -llib1 -llib2 --end-group
21 # --start-group $O_FILES $A_FILES --end-group
22 #
23 # Shared library link:
24 # -shared                       self-explanatory
25 # -fPIC                         position-independent code
26 # --enable-new-dtags            ?
27 # -z,combreloc                  ?
28 # -soname="libbusybox.so.$BB_VER"
29 # --undefined=lbb_main          Seed name to start pulling from
30 #                               (otherwise we'll need --whole-archive)
31 # -static                       Not used, but may be useful! manpage:
32 #                               "... This option can be used with -shared.
33 #                               Doing so means that a shared library
34 #                               is being created but that all of the library's
35 #                               external references must be resolved by pulling
36 #                               in entries from static libraries."
37
38
39 try() {
40     printf "%s\n" "Output of:" >$EXE.out
41     printf "%s\n" "$*" >>$EXE.out
42     printf "%s\n" "==========" >>$EXE.out
43     $debug && echo "Trying: $*"
44     $@ >>$EXE.out 2>&1
45     return $?
46 }
47
48 check_cc() {
49     local tempname="/tmp/temp.$$.$RANDOM"
50     # Can use "-o /dev/null", but older gcc tend to *unlink it* on failure! :(
51     # "-xc": C language. "/dev/null" is an empty source file.
52     if $CC $1 -shared -xc /dev/null -o "$tempname".o >/dev/null 2>&1; then
53         echo "$1";
54     else
55         echo "$2";
56     fi
57     rm "$tempname".o 2>/dev/null
58 }
59
60 check_libc_is_glibc() {
61     local tempname="/tmp/temp.$$.$RANDOM"
62     echo "\
63         #include <stdlib.h>
64         /* Apparently uclibc defines __GLIBC__ (compat trick?). Oh well. */
65         #if defined(__GLIBC__) && !defined(__UCLIBC__)
66         syntax error here
67         #endif
68         " >"$tempname".c
69     if $CC "$tempname".c -c -o "$tempname".o >/dev/null 2>&1; then
70         echo "$2";
71     else
72         echo "$1";
73     fi
74     rm "$tempname".c "$tempname".o 2>/dev/null
75 }
76
77 EXE="$1"
78 CC="$2"
79 CFLAGS="$3"
80 LDFLAGS="$4"
81 O_FILES="$5"
82 A_FILES="$6"
83 LDLIBS="$7"
84
85 # The --sort-section option is not supported by older versions of ld
86 SORT_SECTION=`check_cc "-Wl,--sort-section,alignment" ""`
87
88 # gold may not support --sort-common (yet)
89 SORT_COMMON=`check_cc "-Wl,--sort-common" ""`
90
91 # Static linking against glibc produces buggy executables
92 # (glibc does not cope well with ld --gc-sections).
93 # See sources.redhat.com/bugzilla/show_bug.cgi?id=3400
94 # Note that glibc is unsuitable for static linking anyway.
95 # We are removing -Wl,--gc-sections from link command line.
96 GC_SECTIONS=`(
97 . ./.config
98 if test x"$CONFIG_STATIC" = x"y"; then
99     check_libc_is_glibc "" "-Wl,--gc-sections"
100 else
101     echo "-Wl,--gc-sections"
102 fi
103 )`
104
105 # The --gc-sections option is not supported by older versions of ld
106 if test -n "$GC_SECTIONS"; then
107     GC_SECTIONS=`check_cc "$GC_SECTIONS" ""`
108 fi
109
110 # Sanitize lib list (dups, extra spaces etc)
111 LDLIBS=`echo "$LDLIBS" | xargs -n1 | sort | uniq | xargs`
112
113 # First link with all libs. If it fails, bail out
114 echo "Trying libraries: $LDLIBS"
115 # "lib1 lib2 lib3" -> "-llib1 -llib2 -llib3"
116 l_list=`echo "$LDLIBS" | sed -e 's/ / -l/g' -e 's/^/-l/' -e 's/^-l$//'`
117 test "x$l_list" != "x" && l_list="-Wl,--start-group $l_list -Wl,--end-group"
118 try $CC $CFLAGS $LDFLAGS \
119         -o $EXE \
120         $SORT_COMMON \
121         $SORT_SECTION \
122         $GC_SECTIONS \
123         -Wl,--start-group $O_FILES $A_FILES -Wl,--end-group \
124         $l_list \
125 || {
126     echo "Failed: $l_list"
127     cat $EXE.out
128     exit 1
129 }
130
131 # Now try to remove each lib and build without it.
132 # Stop when no lib can be removed.
133 while test "$LDLIBS"; do
134     $debug && echo "Trying libraries: $LDLIBS"
135     all_needed=true
136     last_needed=false
137     for one in $LDLIBS; do
138         without_one=`echo " $LDLIBS " | sed "s/ $one / /g" | xargs`
139         # "lib1 lib2 lib3" -> "-llib1 -llib2 -llib3"
140         l_list=`echo "$without_one" | sed -e 's/ / -l/g' -e 's/^/-l/' -e 's/^-l$//'`
141         test x"$l_list" != x"" && l_list="-Wl,--start-group $l_list -Wl,--end-group"
142         $debug && echo "Trying -l options: '$l_list'"
143         try $CC $CFLAGS $LDFLAGS \
144                 -o $EXE \
145                 $SORT_COMMON \
146                 $SORT_SECTION \
147                 $GC_SECTIONS \
148                 -Wl,--start-group $O_FILES $A_FILES -Wl,--end-group \
149                 $l_list
150         if test $? = 0; then
151             echo " Library $one is not needed, excluding it"
152             LDLIBS="$without_one"
153             all_needed=false
154             last_needed=false
155         else
156             echo " Library $one is needed, can't exclude it (yet)"
157             last_needed=true
158         fi
159     done
160     # All libs were needed, can't remove any
161     $all_needed && break
162     # Optimization: was the last tried lib needed?
163     if $last_needed; then
164         # Was it the only one lib left? Don't test again then.
165         { echo "$LDLIBS" | grep -q ' '; } || break
166     fi
167 done
168
169 # Make the binary with final, minimal list of libs
170 echo "Final link with: ${LDLIBS:-<none>}"
171 l_list=`echo "$LDLIBS" | sed -e 's/ / -l/g' -e 's/^/-l/' -e 's/^-l$//'`
172 test "x$l_list" != "x" && l_list="-Wl,--start-group $l_list -Wl,--end-group"
173 # --verbose gives us gobs of info to stdout (e.g. linker script used)
174 if ! test -f busybox_ldscript; then
175     try $CC $CFLAGS $LDFLAGS \
176             -o $EXE \
177             $SORT_COMMON \
178             $SORT_SECTION \
179             $GC_SECTIONS \
180             -Wl,--start-group $O_FILES $A_FILES -Wl,--end-group \
181             $l_list \
182             -Wl,--warn-common \
183             -Wl,-Map,$EXE.map \
184             -Wl,--verbose \
185     || {
186         cat $EXE.out
187         exit 1
188     }
189 else
190     echo "Custom linker script 'busybox_ldscript' found, using it"
191     # Add SORT_BY_ALIGNMENT to linker script (found in $EXE.out):
192     #  .rodata         : { *(.rodata SORT_BY_ALIGNMENT(.rodata.*) .gnu.linkonce.r.*) }
193     #  *(.data SORT_BY_ALIGNMENT(.data.*) .gnu.linkonce.d.*)
194     #  *(.bss SORT_BY_ALIGNMENT(.bss.*) .gnu.linkonce.b.*)
195     # This will eliminate most of the padding (~3kb).
196     # Hmm, "ld --sort-section alignment" should do it too.
197     try $CC $CFLAGS $LDFLAGS \
198             -o $EXE \
199             $SORT_COMMON \
200             $SORT_SECTION \
201             $GC_SECTIONS \
202             -Wl,-T,busybox_ldscript \
203             -Wl,--start-group $O_FILES $A_FILES -Wl,--end-group \
204             $l_list \
205             -Wl,--warn-common \
206             -Wl,-Map,$EXE.map \
207             -Wl,--verbose \
208     || {
209         cat $EXE.out
210         exit 1
211     }
212 fi
213
214 . ./.config
215
216 sharedlib_dir="0_lib"
217
218 if test "$CONFIG_BUILD_LIBBUSYBOX" = y; then
219     mkdir "$sharedlib_dir" 2>/dev/null
220     test -d "$sharedlib_dir" || {
221         echo "Cannot make directory $sharedlib_dir"
222         exit 1
223     }
224     ln -s "libbusybox.so.$BB_VER" "$sharedlib_dir"/libbusybox.so 2>/dev/null
225
226     EXE="$sharedlib_dir/libbusybox.so.${BB_VER}_unstripped"
227     try $CC $CFLAGS $LDFLAGS \
228             -o $EXE \
229             -shared -fPIC \
230             -Wl,--enable-new-dtags \
231             -Wl,-z,combreloc \
232             -Wl,-soname="libbusybox.so.$BB_VER" \
233             -Wl,--undefined=lbb_main \
234             $SORT_COMMON \
235             $SORT_SECTION \
236             -Wl,--start-group $A_FILES -Wl,--end-group \
237             $l_list \
238             -Wl,--warn-common \
239             -Wl,-Map,$EXE.map \
240             -Wl,--verbose \
241     || {
242         echo "Linking $EXE failed"
243         cat $EXE.out
244         exit 1
245     }
246     $STRIP -s --remove-section=.note --remove-section=.comment $EXE -o "$sharedlib_dir/libbusybox.so.$BB_VER"
247     chmod a+x "$sharedlib_dir/libbusybox.so.$BB_VER"
248     echo "libbusybox: $sharedlib_dir/libbusybox.so.$BB_VER"
249 fi
250
251 if test "$CONFIG_FEATURE_SHARED_BUSYBOX" = y; then
252     EXE="$sharedlib_dir/busybox_unstripped"
253     try $CC $CFLAGS $LDFLAGS \
254             -o $EXE \
255             $SORT_COMMON \
256             $SORT_SECTION \
257             $GC_SECTIONS \
258             -Wl,--start-group $O_FILES -Wl,--end-group \
259             -L"$sharedlib_dir" -lbusybox \
260             -Wl,--warn-common \
261             -Wl,-Map,$EXE.map \
262             -Wl,--verbose \
263     || {
264         echo "Linking $EXE failed"
265         cat $EXE.out
266         exit 1
267     }
268     $STRIP -s --remove-section=.note --remove-section=.comment $EXE -o "$sharedlib_dir/busybox"
269     echo "busybox linked against libbusybox: $sharedlib_dir/busybox"
270 fi
271
272 if test "$CONFIG_FEATURE_INDIVIDUAL" = y; then
273     echo "Linking individual applets against libbusybox (see $sharedlib_dir/*)"
274     gcc -DNAME_MAIN_CNAME -E -include include/autoconf.h include/applets.h \
275     | grep -v "^#" \
276     | grep -v "^$" \
277     > applet_lst.tmp
278     while read name main junk; do
279
280         echo "\
281 void lbb_prepare(const char *applet, char **argv);
282 int $main(int argc, char **argv);
283
284 int main(int argc, char **argv)
285 {
286         lbb_prepare(\"$name\", argv);
287         return $main(argc, argv);
288 }
289 " >"$sharedlib_dir/applet.c"
290
291         EXE="$sharedlib_dir/$name"
292         try $CC $CFLAGS $LDFLAGS "$sharedlib_dir/applet.c" \
293                 -o $EXE \
294                 $SORT_COMMON \
295                 $SORT_SECTION \
296                 $GC_SECTIONS \
297                 -L"$sharedlib_dir" -lbusybox \
298                 -Wl,--warn-common \
299         || {
300             echo "Linking $EXE failed"
301             cat $EXE.out
302             exit 1
303         }
304         rm -- "$sharedlib_dir/applet.c" $EXE.out
305         $STRIP -s --remove-section=.note --remove-section=.comment $EXE
306
307     done <applet_lst.tmp
308 fi
309
310 # libbusybox.so is needed only for -lbusybox at link time,
311 # it is not needed at runtime. Deleting to reduce confusion.
312 rm "$sharedlib_dir"/libbusybox.so 2>/dev/null
313 exit 0 # or else we may confuse make